namespace BP
{
	namespace Weapon
	{
		class Pistol : ScriptWeapon
		{   
			//------------------------------------------------------------------------------------------------------------------------
			Pistol(kWeapon @actor)
			{
				id = kWpn_Pistol;
				super(actor);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnBeginFire() override
			{
				ScriptWeapon::OnBeginFire();
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnFire() override
			{
				ScriptWeapon::OnFire();
				if (self.AnimTrackComponent().TrackTime() >= 0.8f)
				{
					self.AnimTrackComponent().Flags() |= ANF_CYCLECOMPLETED;
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
		};
	}
}
