#pragma once

//------------------------------------------------------------------------------------------------------------------------
// Actors
//------------------------------------------------------------------------------------------------------------------------
#define BP_Actor_AI_Raptoid						200
#define BP_Actor_AI_Endtrail              			201
#define BP_Actor_AI_CitySoldier           		202
#define BP_Actor_AI_Fireborn 			  			203
#define BP_Actor_AI_Raptor                			300
#define BP_Actor_AI_FleshSentinel 		  		400
#define BP_Actor_AI_DeathGuard 			  	401
#define BP_Actor_AI_LordoftheFlesh 		  	402
#define BP_Actor_AI_Sentinel              			500
#define BP_Actor_AI_Guardian              		501
#define BP_Actor_AI_SpiderHatchling       		502
#define BP_Actor_AI_CaveSpider 			  		503
#define BP_Actor_AI_CaveWorm              	505
#define BP_Actor_AI_Nala 				  			507
#define BP_Actor_AI_Grub                  			511
#define BP_Actor_AI_FleshWorm             		512
#define BP_Actor_AI_WarClub 			  			600
#define BP_Actor_AI_Gunner                		602
#define BP_Actor_AI_Juggernaut            		603
#define BP_Actor_AI_SwampWasp             	604
#define BP_Actor_AI_Mite                  			707
#define BP_Actor_AI_Worker                		708
#define BP_Actor_AI_Drone                 			709
#define BP_Actor_AI_HiveSoldier 		  			710
#define BP_Actor_AI_Deadman               		800
#define BP_Actor_AI_DeadmanHalf           	801
#define BP_Actor_AI_LordoftheDead 		  	803
#define BP_Actor_AI_SisterofDespair 	  		804
#define BP_Actor_AI_QueenPuppet           	888
#define BP_Actor_AI_MotherPuppet          	889
#define BP_Actor_AI_PrimagenTrooper 	  	900
#define BP_Actor_AI_BioBot 				  		901
#define BP_Actor_AI_PrimagenGuard 		  	902
#define BP_Actor_AI_PrimagenDrone         	903
#define BP_Actor_AI_Leaper                			1000
#define BP_Actor_AI_MotherBoss            		1102
#define BP_Actor_AI_EyeBallBoss           		1104
#define BP_Actor_AI_QueenBoss             		1105
#define BP_Actor_AI_Primagen              		1107
#define BP_Actor_AI_Sphincter             		1108
#define BP_Actor_AI_SwampTentacle         	1109
#define BP_Actor_AI_CeilingTentacle       		1110
#define BP_Actor_AI_QueenPod              		1111
#define BP_Actor_AI_MotherGrub            		1112
#define BP_Actor_AI_Compsognathus 			5000
#define BP_Actor_AI_AraissiSoldier 				5007
#define BP_Actor_AI_DroneJetpack	 			5012
#define BP_Actor_AI_PrimagenBoss				5100
#define BP_Actor_AI_Queen							5101
#define BP_Actor_AI_Mother						5102

#define BP_Actor_EventListener					21000
#define BP_Actor_DifCheckEasy					21100
#define BP_Actor_DifCheckNormal				21101
#define BP_Actor_DifCheckHard					21102
#define BP_Actor_DifCheckHardcore				21103
#define BP_Actor_Turret_Hive						21104
#define BP_Actor_Turret_HiveTop					21105
#define BP_Actor_Turret_LShip						21106
#define BP_Actor_Turret_RiverSquareMGun	21107
#define BP_Actor_Turret_RiverCylinderMGun	21108
#define BP_Actor_Turret_RiverArtillery			21109
#define BP_Actor_WarclubRock						21110
#define BP_Actor_MoverPillars						21112

#define BP_Actor_Particle_Blue_Flame			22000
#define BP_Actor_Particle_Large_Bonfire		22001
#define BP_Actor_Particle_Medium_Bonfire	22002
#define BP_Actor_Particle_Small_Bonfire		22003
#define BP_Actor_Particle_Torch					22004
#define BP_Actor_Particle_Torch_Large			22005
#define BP_Actor_Particle_Lava_Rocks			22006
#define BP_Actor_Particle_GraveFog				22007
#define BP_Actor_Particle_FallingRocks			22008

#define BP_Actor_WarpPortal						22014
#define BP_Actor_UIElement							22050
#define BP_Actor_BullsEye							22056

#define BP_Actor_WorldChar 							23000
#define BP_Actor_Controller_Flare					23001
#define BP_Actor_WayPoint 								22600 //AI uses this for going to path
#define BP_Actor_PlatformHivePad					22700
#define BP_Actor_DoorRiverPalace					22701
#define BP_Actor_WorldPoint							22702
#define BP_Actor_Portal									22703
#define BP_Actor_Lava										22704
#define BP_Actor_BigLightBox							22705
#define BP_Actor_Coop_AISpawnPoint				22706
#define BP_Actor_Coop_Inv_HarborPowerCell	22707
#define BP_Actor_SavePortal							22708
#define BP_Actor_SacredPortal							22709

#define BP_Actor_Map								24000
#define BP_Actor_Map_HUB2					24001
#define BP_Actor_Map_HUB						24002
#define BP_Actor_Map_Palace					24003
#define BP_Actor_Map_Port1MP				24500
#define BP_Actor_Map_Port2MP				24501

#define BP_MaxMapType							24999

#define BP_Actor_Destructible_Chest					25000
#define BP_Actor_Destructible_Chest2					25001
#define BP_Actor_Destructible_Barrel					25002
#define BP_Actor_Destructible_Barrel2					25003
#define BP_Actor_Destructible_BarrelPlatform		25004
#define BP_Actor_Destructible_WoodFence			25005
#define BP_Actor_Destructible_CrateNet				25006
#define BP_Actor_Destructible_CrateNet2				25007
#define BP_Actor_Destructible_Padlock					25008
#define BP_Actor_Destructible_Panel						25009
#define BP_Actor_Destructible_Bird1						25010
#define BP_Actor_Destructible_Bird2						25011
#define BP_Actor_Destructible_Bird3						25012
#define BP_Actor_Destructible_Bird4						25013
#define BP_Actor_DestructibleRe_Chest				25014
#define BP_Actor_DestructibleRe_Chest2				25015
#define BP_Actor_DestructibleRe_Barrel				25016
#define BP_Actor_DestructibleRe_Barrel2				25017
#define BP_Actor_DestructibleRe_BarrelPlatform	25018
#define BP_Actor_DestructibleRe_WoodFence		25019
#define BP_Actor_DestructibleRe_CrateNet			25020
#define BP_Actor_DestructibleRe_CrateNet2			25021
#define BP_Actor_DestructibleRe_Padlock				25022
#define BP_Actor_DestructibleRe_Panel					25023
#define BP_Actor_DestructibleRe_Bird1					25024
#define BP_Actor_DestructibleRe_Bird2					25025
#define BP_Actor_DestructibleRe_Bird3					25026
#define BP_Actor_DestructibleRe_Bird4					25027
#define BP_Actor_Destructible_BeeHive					25028

#define BP_Actor_InterAnim_CitySoldier				25500
#define BP_Actor_InterAnim_CitySoliderGun			25501
#define BP_Actor_InterAnim_Iggy							25502
#define BP_Actor_InterAnim_IggyGuns					25503
#define BP_Actor_InterAnim_Primagen					25504
#define BP_Actor_InterAnim_PrimagenTired			25505
#define BP_Actor_InterAnim_TurokCinema			25506
#define BP_Actor_InterAnim_AdonCinema				25507
#define BP_Actor_InterAnim_GreatSpirit				25508
#define BP_Actor_InterAnim_Eyeball						25509
#define BP_Actor_InterAnim_PrimagenDeadTired	25510
#define BP_Actor_InterAnim_CitySoldierKneel		25511
#define BP_Actor_InterAnim_SoulPortal					25512
#define BP_Actor_InterAnim_SoulRing					25513
#define BP_Actor_InterAnim_SoulHeads				25514

#define BP_Actor_Action_Bird								26000
#define BP_Actor_Action_CaveDoorSwitch			26001
#define BP_Actor_Action_CaveWeight					26002
#define BP_Actor_Action_GateKeySwitch				26003
#define BP_Actor_Action_PushCube						26004
#define BP_Actor_Action_SkullLever 						26005
#define BP_Actor_Action_LeverCog 						26006
#define BP_Actor_Action_WoodFloorWreck 			26007
#define BP_Actor_Action_CaveVentRock 				26008
#define BP_Actor_Action_PurlinWall 						26009
#define BP_Actor_Action_RiverTouchLever 			26010
#define BP_Actor_Action_RiverShootLever 			26011
#define BP_Actor_Action_RiverBridge 					26012
#define BP_Actor_Action_CaveBridge 					26013
#define BP_Actor_Action_CaveWallLever 				26014
#define BP_Actor_Action_LShipTurnPanel 				26015
#define BP_Actor_Action_LShipTurnPanel2 			26016
#define BP_Actor_Action_RiverBridge2 					26017
#define BP_Actor_Action_Gear 								26018
#define BP_Actor_Action_HarborTower 				26019
#define BP_Actor_Action_HarborBoat 					26020
#define BP_Actor_Action_HarborWagon 				26021
#define BP_Actor_Action_ExplosiveBox 				26022
#define BP_Actor_Action_LaserDoor 					26023
#define BP_Actor_Action_HarborBridge 				26024
#define BP_Actor_Action_GraveyardKeySwitch 		26025
#define BP_Actor_Action_HarborPowerCell 			26026
#define BP_Actor_Action_MarshBridgeBreak 			26027
#define BP_Actor_Action_LShipGenBeam 				26028
#define BP_Actor_Action_IonCapacitorSwitch 		26029
#define BP_Actor_Action_LShipGenTower 				26030
#define BP_Actor_Action_WarpPortalSwitch 			26031
#define BP_Actor_Action_HiveShieldStraight 			26032
#define BP_Actor_Action_HiveShieldCylinder 			26033
#define BP_Actor_Action_HarborStoneWall 			26034
#define BP_Actor_Action_GoldHorseStatue 			26035
#define BP_Actor_Action_Valve 							26036

#define BP_Actor_Door_MarshWoodGateVert			26500
#define BP_Actor_Door_MarshWoodGateHorz			26501
#define BP_Actor_Door_HarborBlackGate					26502
#define BP_Actor_Door_HarborBlackGate2				26503
#define BP_Actor_Door_RiverSmallDoors					26504
#define BP_Actor_Door_HarborLadder						26505
#define BP_Actor_Door_HarborWall							26506
#define BP_Actor_Door_HiveSpinTube						26507
#define BP_Actor_Door_HiveSpinTube2						26508
#define BP_Actor_Door_OblvDoor								26509
#define BP_Actor_Door_OblvDoor2							26510
#define BP_Actor_Door_RiverGoldSpike					26511
#define BP_Actor_Door_RiverBigSet							26512
#define BP_Actor_Door_GraveFence							26513
#define BP_Actor_Door_RiverStoneWallSlide				26514
#define BP_Actor_Door_BigGate								26515
#define BP_Actor_Door_RiverSmallDoor					26516
#define BP_Actor_Door_RiverStoneSliding					26517
#define BP_Actor_Door_RiverMedStoneSlide				26518
#define BP_Actor_Door_RiverWallExplode					26519
#define BP_Actor_Door_LargeWoodDoor					26520
#define BP_Actor_Door_CaveDoorSlide						26521
#define BP_Actor_Door_HarborSmallDoors				26522
#define BP_Actor_Door_RiverGoldBlackDoors			26523
#define BP_Actor_Door_HarborCornerWall				26524
#define BP_Actor_Door_StoneWallDown					26525
#define BP_Actor_Door_HarborCage							26526
#define BP_Actor_Door_HarborStoneWall					26527
#define BP_Actor_Door_StoneWalSlide						26528
#define BP_Actor_Door_CrawlSpace							26529
#define BP_Actor_Door_HarborWoodDoors				26530
#define BP_Actor_Door_HarborWoodDoors2				26531
#define BP_Actor_Door_WarpPortal							26532
#define BP_Actor_Door_RiverSoulDoor						26533
#define BP_Actor_Door_RiverFancyDoors					26534
#define BP_Actor_Door_OblvRoundHatch					26535
#define BP_Actor_Door_RiverBigSetOpen					26536
#define BP_Actor_Door_GraveFenceAuto					26537
#define BP_Actor_Door_OblvRoundHatchAuto			26538
#define BP_Actor_Door_RiverSmallDoorsAuto			26539
#define BP_Actor_Door_LShipSmallDoor					26540
#define BP_Actor_Door_RiverGoldBlackDoorsOpen	26541
#define BP_Actor_Door_CaveDoorSlideAuto				26542



#define BP_Actor_Platform_FloatRock				27000
#define BP_Actor_Platform_LavaRock				27001
#define BP_Actor_Platform_LShipHover				27002
#define BP_Actor_Platform_MarshWoodLogs		27003
#define BP_Actor_Platform_Crate						27004
#define BP_Actor_Platform_CrateMove				27005

#define BP_Actor_Gen_SwampWasp					27500


#define BP_Actor_Music_Frosty						65000

#define BP_Actor_Sound_FireBurning				66000
#define BP_Actor_Sound_LavaGloop					66001
#define BP_Actor_Sound_WaterFall					66002
#define BP_Actor_Sound_WaterFountain			66003
#define BP_Actor_Sound_WaterLapping			66004
#define BP_Actor_Sound_Wind1						66005
#define BP_Actor_Sound_HiveComputer1			66006
#define BP_Actor_Sound_Wind3						66007
#define BP_Actor_Sound_HiveComputer2			66008
#define BP_Actor_Sound_HiveComputer3			66009
#define BP_Actor_Sound_HiveGenerator1			66010
#define BP_Actor_Sound_HiveGenerator2			66011
#define BP_Actor_Sound_HiveGenerator3			66012
#define BP_Actor_Sound_HiveForceField1			66013
#define BP_Actor_Sound_HiveForceField2			66014
#define BP_Actor_Sound_HiveForceField3			66015
#define BP_Actor_Sound_ComputerLoop			66016
#define BP_Actor_Sound_FleshPiston				66017
#define BP_Actor_Sound_FleshFan					66018

//------------------------------------------------------------------------------------------------------------------------
// Particles
//------------------------------------------------------------------------------------------------------------------------
#define BP_Particle_GroundPound     			500
#define BP_Particle_FlareDamage	    			502
#define BP_Particle_CharStart						800 //800 to 927 are reserved for ascii characters
#define BP_Particle_Small_Blue_Bonfire			1200
#define BP_Particle_Primagen_Shot				1201
#define BP_Particle_Flame_Thrower				1202


//------------------------------------------------------------------------------------------------------------------------
// Weapons
//------------------------------------------------------------------------------------------------------------------------
#define MAX_WEAPONS	33

//------------------------------------------------------------------------------------------------------------------------
// Inventory Items
//------------------------------------------------------------------------------------------------------------------------
#define BP_Actor_Inventory_GenericKey			4000 //to 4019, 4021 to 4024, 4026 to 4029, 4031 (never used)
#define BP_Actor_Inventory_CaveDoorKey		4020
#define BP_Actor_Inventory_GraveyardKey		4025
#define BP_Actor_Inventory_KeyGate				4030
#define BP_Actor_Inventory_Satchel					4100 //and 4112 to 4131 (only 4100 is used)
#define BP_Actor_Inventory_ThermalSatchel		4111
#define BP_Actor_Inventory_PowerCell				4200 //to 4228 (only 4200 used)
#define BP_Actor_Inventory_RedLaserCell			4229
#define BP_Actor_Inventory_BlueLaserCell		4230
#define BP_Actor_Inventory_IonCapacitor			4231
#define BP_Actor_Inventory_Level1Key			4300 //never used
#define BP_Actor_Inventory_Level2Key			4310
#define BP_Actor_Inventory_Level3Key			4320
#define BP_Actor_Inventory_Level4Key			4330
#define BP_Actor_Inventory_Level5Key			4340
#define BP_Actor_Inventory_Level6Key			4350
#define BP_Actor_Inventory_PrimKey1				4360
#define BP_Actor_Inventory_PrimKey2				4361
#define BP_Actor_Inventory_PrimKey3				4362
#define BP_Actor_Inventory_PrimKey4				4363
#define BP_Actor_Inventory_PrimKey5				4364
#define BP_Actor_Inventory_PrimKey6				4365
#define BP_Actor_Inventory_Level2Talisman		4382
#define BP_Actor_Inventory_Level3Talisman		4380
#define BP_Actor_Inventory_Level4Talisman		4384
#define BP_Actor_Inventory_Level5Talisman		4383
#define BP_Actor_Inventory_Level6Talisman		4381
#define BP_Actor_Inventory_Level2Feather		4402
#define BP_Actor_Inventory_Level3Feather		4400
#define BP_Actor_Inventory_Level4Feather		4404
#define BP_Actor_Inventory_Level5Feather		4403
#define BP_Actor_Inventory_Level6Feather		4401
#define BP_Actor_Inventory_NukePart				4500

#define BP_Actor_Inventory_AirJump						5000
#define BP_Actor_Inventory_Mag60Upgrade				5001
#define BP_Actor_Inventory_GroundPoundUpgrade	5002
#define BP_Actor_Inventory_RazorWindUpgrade		5003

//------------------------------------------------------------------------------------------------------------------------
// Sounds
//------------------------------------------------------------------------------------------------------------------------
#define BP_SFX_Slap							6100

//------------------------------------------------------------------------------------------------------------------------
// HUBs
//------------------------------------------------------------------------------------------------------------------------
#define BP_HUB_Main							20
#define BP_HUB_Jungle						21
#define BP_HUB_Palace						22

//------------------------------------------------------------------------------------------------------------------------
// Levels
//------------------------------------------------------------------------------------------------------------------------
#define BP_Level_HUB								600
#define BP_Level_HUB2							601
#define BP_Level_Jungle1							602
#define BP_Level_Palace							603

#define BP_Level_Coop_Port1					1000
#define BP_Level_Coop_Port2					1001

//------------------------------------------------------------------------------------------------------------------------
// Mission Objectives
//------------------------------------------------------------------------------------------------------------------------
#define BP_MisObj_Jungle 	100
#define BP_MisObj_Palace1 	101
#define BP_MisObj_Palace2 	102
#define BP_MisObj_Palace3 	103

//------------------------------------------------------------------------------------------------------------------------
// Generate Flags
//------------------------------------------------------------------------------------------------------------------------
#define GENERATE_FLAG_HEALTH2			(1 << 0)
#define GENERATE_FLAG_HEALTH10			(1 << 1)
#define GENERATE_FLAG_HEALTHFULL		(1 << 2)
#define GENERATE_FLAG_HEALTHULTRA	(1 << 3) //generateactor and enemy drops will only spawn if health is below 250
#define GENERATE_FLAG_LIFEFORCE1		(1 << 4)
#define GENERATE_FLAG_LIFEFORCE10	(1 << 5)
#define GENERATE_FLAG_ARROWS			(1 << 6)
#define GENERATE_FLAG_QUIVER				(1 << 7)
#define GENERATE_FLAG_TEKARROWS		(1 << 8)
#define GENERATE_FLAG_TEKQUIVER		(1 << 9)
#define GENERATE_FLAG_CLIP					(1 << 10)
#define GENERATE_FLAG_TRANQDARTS	(1 << 11)
#define GENERATE_FLAG_TRANQPACK		(1 << 12)
#define GENERATE_FLAG_CHARGE			(1 << 13)
#define GENERATE_FLAG_CHARGEPACK	(1 << 14)
#define GENERATE_FLAG_SHELLS				(1 << 15)
#define GENERATE_FLAG_SHELLBOX			(1 << 16)
#define GENERATE_FLAG_EXPSHELL			(1 << 17)
#define GENERATE_FLAG_PLASMA			(1 << 18)
#define GENERATE_FLAG_PLASMAPACK	(1 << 19)
#define GENERATE_FLAG_SUNFIREPODS	(1 << 20)
#define GENERATE_FLAG_BORES				(1 << 21)
#define GENERATE_FLAG_PFM					(1 << 22)
#define GENERATE_FLAG_GRENADE			(1 << 23)
#define GENERATE_FLAG_GRENADEBOX	(1 << 24)
#define GENERATE_FLAG_MISSILES			(1 << 25)
#define GENERATE_FLAG_SPEARS				(1 << 26)
#define GENERATE_FLAG_TORPEDO			(1 << 27)
#define GENERATE_FLAG_CLIP2				(1 << 28)
#define GENERATE_FLAG_EXPSHELL2		(1 << 29)
#define GENERATE_FLAG_SHELLS2			(1 << 30)
#define GENERATE_FLAG_GASTANK			(1 << 31) //generateactor and enemy drops will not spawn this

#define GENERATE_FLAG2_NUKE				(1 << 0)
