//TID
//999 Palace Map
//63000 Start Warp Point
//1001 Trigger Enemies 1
//1002 Enemies 1
//1003 Mover Pillars
//1004 Mover Pillars Trigger
//1005 Enemies 2
//1006 Enemies 2 Trigger
//1007 Enemies 3
//1008 Enemies 3 Trigger
//1009 Enemies 4
//1010 Enemies 4 Trigger
//1011 Key Area Pickup
//1012 Queen
//1013 Queen Enemies
//1014 
//1015 

namespace BP
{
	namespace Maps
	{
		class Palace : ScriptMap
		{
			//------------------------------------------------------------------------------------------------------------------------
			Palace(kActor@ actor)
			{
				super(actor);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnStart() override
			{
				ScriptMap::BP_OnStart();
				
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnPlayerCreated(kActor@ actor) override
			{
				ScriptMap::OnPlayerCreated(actor);
				
				kPuppet@ puppet = actor.CastToPuppet();
				puppet.PlayerOwner().GiveWeapon(kWpn_SunfirePod, 2);
				puppet.PlayerOwner().GiveWeapon(kWpn_Shotgun, 20);
				puppet.PlayerOwner().GiveWeapon(kWpn_Magnum, 50);
				BP::Inventory::Give(BP_Actor_Inventory_Mag60Upgrade, 1, puppet.PlayerOwner());
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnSerialize(kDict dict) override
			{
				ScriptMap::BP_OnSerialize(dict);
				// SERIALIZE_INT(generators);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnDeserialize(kDict& in dict) override
			{
				ScriptMap::BP_OnDeserialize(dict);
				// DESERIALIZE_INT(generators);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnTrigger(kActor@ pInstigator, const int msg) override
			{
				ScriptMap::BP_OnTrigger(pInstigator, msg);
				
				switch (self.TriggerMessageID())
				{
					case 1:
					{
						break;
					}
					case 2:
					{
						break;
					}
					default:
					{
						break;
					}
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
		};
	}
}
