namespace BP
{
	//1 time for all (weapons)
	//1 time for any (everything thing else)
	//create a generator point that spawns a generator at that location
	//everything needs a TID so I can store if it's been marked or not
	
	//map has int32s of flags for each TID what TID the flag corresponds to is predefinied in the map script
	//store each players weapons and ammo count and health(as int and ceil the value)
	//store inventory for only the server player
	
	namespace Actors
	{
		//only for inventory pickups
		class PickupInventory : BP::ScriptActor
		{
			int inventoryID;
			kStr pickupSound;
			kStr pickupMessage;
			
			// kPuppet@ lastTouchPuppet;
			//------------------------------------------------------------------------------------------------------------------------
			PickupInventory(kActor@ actor)
			{
				super(actor);
				
				// if (self.MovementComponent() !is null)
				// {
					// self.MovementComponent().Flags() &= ~MCF_PROCESS_MOVEMENT;
				// }
				
				// if (self.HasComponent("kexInventoryPickup"))
				// {
					// //
				// }
				
				kDictMem@ def = self.Definition();
				if (def !is null)
				{
					def.GetInt("inventoryID", inventoryID);
					def.GetString("pickupSound", pickupSound);
					def.GetString("pickupMessage", pickupMessage);
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
			// ~InventoryPickupMP()
			// {
				// if (lastTouchPuppet !is null)
				// {
					// if (IsNetServer)
					// {
						// BP_OnPickup();
						// DoNetSend();
					// }
				// }
			// }
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnNetSend() override
			{
				NetWorkWriteActor(@self);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnNetReceive(array<int>& int32Args, array<int16>& int16Args) override
			{
				BP_OnPickup();
			}
			//------------------------------------------------------------------------------------------------------------------------
			// Find closest generator within a certain radius of it's position and set target to that generator
			//------------------------------------------------------------------------------------------------------------------------
			// void SetClosestGenerator()
			// {
				// FOREACH_ACTOR
				// {
					
				// }
			// }
			//------------------------------------------------------------------------------------------------------------------------
			// void BP_OnStart() override
			// {
				// SetClosestGenerator();
			// }
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnTouch(kActor@ instigator) override
			{
				if (instigator.Type() == kActor_Player && !BP::Actor::IsDead(instigator))
				{
					//@lastTouchPuppet = instigator.CastToPuppet();
					if (IsNetServer)
					{
						DoNetSend();
					}
					BP_OnPickup();
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnPickup()
			{
				for (int i = 0; i < int(BP::mapScript.playerActors.length()); i++)
				{
					kActor@ actor = @BP::mapScript.playerActors[i];
					BP::Inventory::Give(inventoryID, 1, actor.CastToPuppet().PlayerOwner());
				}
				
				self.PlaySound(pickupSound);
				Hud.AddMessage(pickupMessage);
				self.Mark(true);
				self.Remove();
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnSpawn() override
			{
				if (self.IsMarked())
				{
					self.Remove();
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnTick() override
			{
				self.Yaw() += 0.017453f;
			}
			//------------------------------------------------------------------------------------------------------------------------
		};
	}
}
