namespace BP
{
	kActor@ map;
	BP::Maps::ScriptMap@ mapScript;
	namespace Map
	{
		//------------------------------------------------------------------------------------------------------------------------
		void OnCreate()
		{
			//load and spawn a map controller actor if map def has one else spawn a default map controller
			if (map is null)
			{
				@map = BP::Spawn::Actor(BP_Actor_Map, Math::vecZero);
				DebugAssert(map !is null, "[BP::Map::OnCreate] map is null");
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnDestroy()
		{
			if (map !is null)
			{
				@map = null;
				@mapScript = null;
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
	}
}
